Archimedes.activeTicks = {}
Archimedes.Castbar = {}
function Archimedes.Tick()
  for v, cast in pairs(Archimedes.activeTicks) do
    for arc,opt in pairs(Archimedes.Options.arcs) do
      if opt.type == "castbar" then  -- Make sure I'm a castbar
      if Inspect.Unit.Lookup(opt.unit) == cast.unit then -- Make sure the target is correct
      if Inspect.Unit.Castbar(cast.unit) then
        --print((cast.begin + cast.duration) - Inspect.Time.Frame())
        if cast.channeled then
          Archimedes.activeArcs[arc]:SetNew(Inspect.Unit.Castbar(opt.unit).remaining)
        else
         Archimedes.activeArcs[arc]:SetNew(cast.duration - Inspect.Unit.Castbar(opt.unit).remaining)
        end

      else
        --print("Interrupt")

      end
      end
      end
    end
  end
end

function Archimedes.Castbar.ShowHide(unit, arc, active, instant)
 if active then
      if Archimedes.activeArcs[arc].fade then
        Archimedes.activeArcs[arc].fade:Stop()
        Archimedes.activeArcs[arc].fade = nil
      end
      Archimedes.activeTicks[arc] =  {unit = unit, duration = Inspect.Unit.Castbar(unit).duration, begin = Inspect.Unit.Castbar(unit).begin, channeled = Inspect.Unit.Castbar(unit).channeled}
      Archimedes.activeArcs[arc]:SetNew(Inspect.Unit.Castbar(unit).duration, "max")
      Archimedes.activeArcs[arc]:SetVisible(true)
 else
      if Archimedes.activeArcs[arc].fade then
      Archimedes.activeArcs[arc].fade:Stop()
      Archimedes.activeArcs[arc].fade = nil
      end
      Archimedes.activeArcs[arc]:SetNew(1, "max")
      Archimedes.activeArcs[arc]:SetNew(1)
      --Archimedes.activeArcs[arc].texture:SetTexture()
      --if not Archimedes.activeTicks[arc] then Archimedes.activeTicks[arc] = true end
      if Archimedes.activeTicks[arc] then if Archimedes.activeTicks[arc].channeled then instant = true end end
      if (not instant) then Archimedes.activeArcs[arc]:FadeOut() else Archimedes.activeArcs[arc]:SetVisible(false) end
      Archimedes.activeTicks[arc] = nil
 end
end
function Archimedes.Castbar.AddRemove(unit, active, instant)
  for arc,opt in pairs(Archimedes.Options.arcs) do
    if opt.type == "castbar" then
      if Inspect.Unit.Lookup(opt.unit) == unit then
        Archimedes.Castbar.ShowHide(unit, arc, active, instant)
      end
      end
  end
end

function Archimedes.Castbar.Handler(unit)
  for unit, active in pairs(unit) do
    Archimedes.Castbar.AddRemove(unit, active)
  end
end

table.insert(Event.Unit.Castbar, {Archimedes.Castbar.Handler, "Archimedes", "Not initialised"})